"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleMixMaterials = exports.handleMixMode = void 0;
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importStar(require("fs-extra"));
const mp_1 = require("../util/mp");
const plugin_1 = require("../service/builder/plugin");
const lodash_1 = __importDefault(require("lodash"));
const chalk_1 = __importDefault(require("chalk"));
const generateFiles_1 = require("../util/generateFiles");
const webpack_1 = require("../service/builder/webpack");
function handleMixMode({ apps = [], generateMpPath, miniprogramRoot, plugins = [], }) {
    return __awaiter(this, void 0, void 0, function* () {
        yield handleSubApps();
        yield webpack_1.installDependencies(miniprogramRoot);
        yield handlePlugins();
        function handleMainApp() {
            return __awaiter(this, void 0, void 0, function* () {
                const aloneDirs = ['common', 'app', 'lowcode', 'materials'];
                const dirs = aloneDirs;
                yield Promise.all(dirs.map((dirname) => __awaiter(this, void 0, void 0, function* () {
                    const srcDir = path_1.default.join(miniprogramRoot, dirname);
                    if (yield fs_extra_1.default.pathExists(srcDir)) {
                        const distDir = path_1.default.join(generateMpPath, dirname);
                        if (aloneDirs.includes(dirname)) {
                            yield fs_extra_1.default.remove(distDir);
                        }
                        yield fs_extra_1.default.copy(srcDir, distDir);
                    }
                })));
            });
        }
        function handleAppPages() {
            return __awaiter(this, void 0, void 0, function* () {
                const srcDir = path_1.default.join(miniprogramRoot, 'pages');
                const distDir = path_1.default.join(generateMpPath, 'pages');
                const pageList = yield fs_extra_1.default.readdir(srcDir);
                yield Promise.all(pageList.map((page) => __awaiter(this, void 0, void 0, function* () {
                    const srcPageDir = path_1.default.join(srcDir, page);
                    const srcDistDir = path_1.default.join(distDir, page);
                    if (yield fs_extra_1.default.pathExists(srcDistDir)) {
                        console.log(chalk_1.default.yellow(`【混合模式】 WeApps 中的 pages/${page} 与小程序 pages/${page} 重复，会以 WeApps 的为主`));
                    }
                    yield fs_extra_1.default.copy(srcPageDir, srcDistDir);
                })));
            });
        }
        function handleSubApps() {
            return __awaiter(this, void 0, void 0, function* () {
                let modifiedAppJson = false;
                const rootAppJosnPath = path_1.default.join(miniprogramRoot, 'app.json');
                let rootAppJosn = yield fs_extra_1.default.readJSON(rootAppJosnPath);
                let modifiedPackageJosn = false;
                const rootPackageJosnPath = path_1.default.join(miniprogramRoot, 'package.json');
                let rootPackageJson = fs_extra_1.default.existsSync(rootPackageJosnPath)
                    ? yield fs_extra_1.default.readJson(rootPackageJosnPath)
                    : {
                        name: 'WeDa-app',
                        version: '1.0.0',
                    };
                let mergeDependencies = {};
                yield Promise.all(apps
                    .filter((app) => app.rootPath)
                    .map((app) => __awaiter(this, void 0, void 0, function* () {
                    const subAppPath = path_1.default.join(miniprogramRoot, app.rootPath || '');
                    const appJsonPath = path_1.default.join(subAppPath, 'app.json');
                    if (fs_extra_1.default.existsSync(appJsonPath)) {
                        let appJson = yield fs_extra_1.default.readJson(appJsonPath);
                        if (appJson) {
                            let { subpackages = [] } = rootAppJosn;
                            const find = subpackages.find((item) => item.root == app.rootPath);
                            if (find) {
                                find.pages = appJson.pages;
                            }
                            else {
                                if (!rootAppJosn.subpackages) {
                                    rootAppJosn.subpackages = [];
                                }
                                rootAppJosn.subpackages.push({
                                    root: app.rootPath,
                                    pages: appJson.pages,
                                });
                            }
                            modifiedAppJson = true;
                        }
                    }
                    const packageJosnPath = path_1.default.join(subAppPath, 'package.json');
                    if (fs_extra_1.default.existsSync(packageJosnPath)) {
                        mergeDependencies = Object.assign(Object.assign({}, mergeDependencies), (yield mp_1.mergePackageDependiences(mergeDependencies, yield fs_extra_1.default.readJson(packageJosnPath))));
                        modifiedPackageJosn = true;
                    }
                    yield Promise.all([
                        'app.json',
                        'app.js',
                        'app.wxss',
                        'project.config.json',
                        'package.json',
                        'node_modules',
                        'miniprograme_npm',
                    ].map((name) => {
                        let clearPath = path_1.default.join(subAppPath, name);
                        return name.includes('.')
                            ? generateFiles_1.removeFile(clearPath)
                            : generateFiles_1.cleanDir(clearPath, []);
                    }));
                })));
                if (modifiedAppJson) {
                    yield fs_extra_1.writeFile(rootAppJosnPath, JSON.stringify(rootAppJosn, undefined, 2));
                }
                if (modifiedPackageJosn) {
                    yield fs_extra_1.writeFile(rootPackageJosnPath, JSON.stringify(Object.assign(Object.assign({}, rootPackageJson), mp_1.mergePackageDependiences(mergeDependencies, rootPackageJson)), undefined, 2));
                }
            });
        }
        function handlePlugins() {
            return __awaiter(this, void 0, void 0, function* () {
                const mpPlugins = (yield plugin_1.getPluginType(generateMpPath, plugins)).filter((item) => item.type === 'mp');
                return Promise.all(mpPlugins.map((plugin) => __awaiter(this, void 0, void 0, function* () {
                    const pluginModule = plugin.module;
                    const pluginNodeModuleDir = path_1.default.resolve(generateMpPath, 'node_modules', pluginModule);
                    const pluginPkgJson = yield fs_extra_1.default.readJson(path_1.default.join(pluginNodeModuleDir, 'package.json'));
                    const { pluginName } = pluginPkgJson;
                    const pluginDir = path_1.default.join(miniprogramRoot, pluginName);
                    const distDir = path_1.default.join(generateMpPath, pluginName);
                    yield fs_extra_1.default.copy(pluginDir, distDir, { overwrite: true });
                })));
            });
        }
        function handleAppJson() {
            return __awaiter(this, void 0, void 0, function* () {
                const baseAppJsonPath = path_1.default.join(generateMpPath, 'app.json');
                const mergeAppJsonPath = path_1.default.join(miniprogramRoot, 'app.json');
                yield mp_1.mergePages(baseAppJsonPath, mergeAppJsonPath);
                yield mp_1.mergeSubPackages(baseAppJsonPath, mergeAppJsonPath);
            });
        }
        function handlePkgJson() {
            return __awaiter(this, void 0, void 0, function* () {
                const basePkgJsonPath = path_1.default.join(generateMpPath, 'package.json');
                const mergePkgJsonPath = path_1.default.join(miniprogramRoot, 'package.json');
                yield mp_1.mergePackageJson(basePkgJsonPath, mergePkgJsonPath);
            });
        }
    });
}
exports.handleMixMode = handleMixMode;
function handleMixMaterials(projDir, apps, appUsedComps, compositedLibs) {
    return __awaiter(this, void 0, void 0, function* () {
        return Promise.all(apps.map((app) => __awaiter(this, void 0, void 0, function* () {
            var _a;
            const rootPath = app.rootPath || '';
            const materialsDirPath = path_1.default.join(projDir, rootPath, 'materials');
            const usedComps = ((_a = appUsedComps.find((item) => item.rootPath === rootPath)) === null || _a === void 0 ? void 0 : _a.usedComps) ||
                {};
            const materialsLib = yield readDirs(materialsDirPath);
            const cleanLibs = lodash_1.default.difference(materialsLib, Object.keys(usedComps));
            yield removeDirs(cleanLibs.map((libName) => path_1.default.join(materialsDirPath, libName)));
            yield Promise.all(Object.keys(usedComps).map((libName) => __awaiter(this, void 0, void 0, function* () {
                if (!compositedLibs.find((item) => item.name === libName)) {
                    return;
                }
                const libComponents = usedComps[libName];
                const materialsLibComps = yield readDirs(path_1.default.join(materialsDirPath, libName));
                const cleanComps = lodash_1.default.difference(materialsLibComps, Array.from(libComponents));
                yield removeDirs(cleanComps.map((compName) => path_1.default.join(materialsDirPath, libName, compName)));
            })));
        })));
    });
}
exports.handleMixMaterials = handleMixMaterials;
function removeDirs(dirs) {
    return __awaiter(this, void 0, void 0, function* () {
        return Promise.all(dirs.map((dir) => {
            console.log('【MIX MODE 清理】', dir);
            return fs_extra_1.default.remove(dir);
        }));
    });
}
function readDirs(dirPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const isDirectory = (source) => fs_extra_1.lstatSync(source).isDirectory();
        return ((yield fs_extra_1.default.readdir(dirPath)) || []).filter((name) => isDirectory(path_1.default.join(dirPath, name)));
    });
}
