"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.genCompositeComponentLibraries = exports.copyMaterialLibraries = exports.copyEntryFile = void 0;
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importStar(require("fs-extra"));
const lodash_template_1 = __importDefault(require("lodash.template"));
const json_schema_defaults_1 = __importDefault(require("json-schema-defaults"));
const lodash_1 = __importDefault(require("lodash"));
const util_1 = require("../../util");
const weapps_core_1 = require("../../../weapps-core");
const config_1 = require("../../config");
const generate_1 = require("./generate");
const junk = __importStar(require("../../util/junk"));
function copyEntryFile(appBuildDir, appContent, adminPortalKey) {
    return __awaiter(this, void 0, void 0, function* () {
        const entryFilePath = path_1.default.resolve(config_1.appTemplateDir, './src/index.jsx');
        const content = yield fs_extra_1.default.readFile(entryFilePath);
        yield fs_extra_1.default.writeFile(path_1.default.join(appBuildDir, 'src/index.jsx'), lodash_template_1.default(content + '')(Object.assign({ adminPortalKey, yyptAppKey: '', reportUrl: '', stopReport: false }, appContent)), { flag: 'w' });
    });
}
exports.copyEntryFile = copyEntryFile;
function copyMaterialLibraries(dependencies = [], materialsDir, appBuildDir) {
    return __awaiter(this, void 0, void 0, function* () {
        const localPkg = util_1.getCurrentPackageJson();
        yield Promise.all(dependencies.map((componentLib) => __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c, _d, _e;
            const { name, version } = componentLib;
            const materialNameVersion = `${name}@${version}`;
            const materialDir = path_1.default.join(materialsDir, materialNameVersion);
            const srcDir = 'src';
            let targetDir = path_1.default.join(materialDir, srcDir);
            if (localPkg && localPkg.name === name && localPkg.version === version) {
                console.log('当前本地目录是素材库的时候，直接用本地的', materialNameVersion);
                targetDir = path_1.default.join(process.cwd(), 'src');
            }
            const librariesDir = path_1.default.join(appBuildDir, 'src/libraries', materialNameVersion);
            const metaJosnPath = path_1.default.join(materialDir, 'meta.json');
            if (fs_extra_1.default.existsSync(metaJosnPath)) {
                yield fs_extra_1.default.copy(metaJosnPath, path_1.default.join(librariesDir, 'meta.json'));
            }
            yield fs_extra_1.default.copy(targetDir, librariesDir, {
                filter: (src, dest) => {
                    let path = src.split('/');
                    return !junk.is(path[path.length - 1]);
                },
            });
            try {
                const meta = util_1.readComponentLibMata(librariesDir);
                let [major] = ((_a = meta === null || meta === void 0 ? void 0 : meta.schemaVersion) === null || _a === void 0 ? void 0 : _a.split('.')) || [];
                if (Number(major) >= 3) {
                    componentLib['isPlainProps'] = true;
                }
            }
            catch (e) { }
            try {
                const packageJson = fs_extra_1.readJsonSync(path_1.default.join(materialDir, 'package.json'));
                if ((_c = (_b = packageJson.weda) === null || _b === void 0 ? void 0 : _b.platform) === null || _c === void 0 ? void 0 : _c.web) {
                    const entries = (_e = (_d = packageJson.weda) === null || _d === void 0 ? void 0 : _d.platform) === null || _e === void 0 ? void 0 : _e.web;
                    componentLib['entries'] = {
                        entry: path_1.default.posix.relative(srcDir, entries.entry),
                        components: path_1.default.posix.relative(srcDir, entries.components),
                        actions: path_1.default.posix.relative(srcDir, entries.actions),
                    };
                }
                else if (packageJson.lowcode) {
                    const entry = path_1.default.posix.relative(srcDir, packageJson.lowcode);
                    componentLib['entries'] = {
                        entry,
                    };
                }
            }
            catch (e) { }
        })));
    });
}
exports.copyMaterialLibraries = copyMaterialLibraries;
function genCompositeComponentLibraries(dependencies = [], appBuildDir, materialGroupInfoMap = {}, componentsInfoMap) {
    return __awaiter(this, void 0, void 0, function* () {
        yield Promise.all(dependencies.map(({ name, version, components }) => __awaiter(this, void 0, void 0, function* () {
            const materialNameVersion = `${name}@${version}`;
            const librariesDir = path_1.default.join(appBuildDir, 'src/libraries', materialNameVersion);
            yield Promise.all(components.map((component) => __awaiter(this, void 0, void 0, function* () {
                let compItem = component;
                compItem.materialName = name;
                const wrapperClass = weapps_core_1.getCompositedComponentClass(compItem);
                const componentSchemaJson = {
                    type: 'object',
                    properties: weapps_core_1.readCmpInstances(compItem.componentInstances),
                };
                const { widgets, dataBinds, componentSchema } = generate_1.getComponentSchemaString(componentSchemaJson, true, componentsInfoMap, wrapperClass);
                const templateData = {
                    id: compItem.id,
                    name: compItem.name,
                    defaultProps: json_schema_defaults_1.default({
                        type: 'object',
                        properties: compItem.dataForm || {},
                    }),
                    compConfig: compItem.compConfig || {},
                    emitEvents: JSON.stringify(compItem.emitEvents.map((evt) => evt.eventName)),
                    handlersImports: compItem.lowCodes.filter((codeItem) => codeItem.type === 'handler-fn' &&
                        codeItem.name !== '____index____'),
                    useComponents: (function () {
                        const list = [];
                        JSON.stringify(compItem.componentInstances, (key, value) => {
                            var _a;
                            if (key === 'xComponent') {
                                const { moduleName, name } = value;
                                const compLib = materialGroupInfoMap[moduleName];
                                let isPlainProps = false;
                                if (compLib) {
                                    const { schemaVersion = '' } = compLib;
                                    try {
                                        if (Number((_a = schemaVersion.split('.')) === null || _a === void 0 ? void 0 : _a[0]) >= 3) {
                                            isPlainProps = true;
                                        }
                                    }
                                    catch (e) { }
                                }
                                list.push({
                                    moduleName,
                                    name,
                                    key: `${moduleName}:${name}`,
                                    var: lodash_1.default.upperFirst(lodash_1.default.camelCase(`${moduleName}:${name}`)),
                                    moduleNameVar: lodash_1.default.camelCase(moduleName),
                                    version: (compLib === null || compLib === void 0 ? void 0 : compLib.version) || '',
                                    entries: compLib === null || compLib === void 0 ? void 0 : compLib.entries,
                                    isPlainProps: isPlainProps,
                                });
                            }
                            return value;
                        });
                        return lodash_1.default.uniqBy(list, 'key');
                    })(),
                    widgets,
                    dataBinds,
                    componentSchema,
                    pageListenerInstances: generate_1.getListenersString(compItem.listeners, true),
                    materialName: name,
                };
                const dest = path_1.default.resolve(librariesDir, `./components/${compItem.name}/index.jsx`);
                const template = yield fs_extra_1.default.readFile(path_1.default.resolve(config_1.appTemplateDir, './src/pages/composite.tpl'), {
                    encoding: 'utf8',
                });
                const jsx = lodash_template_1.default(template)(templateData);
                yield fs_extra_1.default.ensureFile(dest);
                yield fs_extra_1.default.writeFile(dest, jsx);
            })));
        })));
    });
}
exports.genCompositeComponentLibraries = genCompositeComponentLibraries;
