"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const plugin = (opts = {}) => {
    const { zoom = 1 } = opts || {};
    const pxRegExp = /\b(\d+(\.\d+)?)px\b/g;
    return {
        postcssPlugin: 'wx-px2rpx',
        Once(root, { result }) {
            root.replaceValues(pxRegExp, { fast: 'px' }, (string) => {
                return `${zoom * parseInt(string)}rpx`;
            });
        },
    };
};
plugin.postcss = true;
exports.default = plugin;
